import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import * as React from "react";
import { Dialog, DialogClose, DialogContent, DialogDescription, DialogHeading } from "./Dialog";
import { Button } from "./Button";
import { useTheme } from "./Theme/Providers";
import { Text } from "./Text";
//确认进一步的操作的对话框。
export const AlertDialog = ({ isOpen, title, subtitle, confirmLabel = "Confirm", onConfirm, intent = "danger", onCancel, onClose }) => {
    const theme = useTheme();
    // const id = useUid();
    const cancel = React.useCallback(() => {
        if (onCancel)
            onCancel();
        onClose();
    }, [onCancel, onClose]);
    const confirm = React.useCallback(() => {
        onConfirm();
        onClose();
    }, [onConfirm]);
    return (_jsx(Dialog, { open: isOpen, onOpenChange: cancel, children: _jsxs(DialogContent, { children: [_jsx(DialogHeading, { children: title }), _jsx(DialogDescription, { children: _jsxs("div", { css: { padding: "1.5rem" }, children: [subtitle && _jsx(Text, { children: subtitle }), _jsx("div", { css: {
                                    marginTop: theme.spaces.md,
                                    display: "flex",
                                    justifyContent: "flex-end"
                                }, children: _jsx(Button, { onPress: confirm, css: { marginLeft: theme.spaces.sm }, intent: intent, children: confirmLabel }) })] }) }), _jsx(DialogClose, { css: { padding: theme.spaces.xs }, children: "\u53D6\u6D88" })] }) }));
};
//# sourceMappingURL=AlertDialog.js.map