/** @jsxImportSource @emotion/react */
import * as React from "react";
import { InputSize } from "./Form";
export interface BlobInputListProps extends React.TextareaHTMLAttributes<HTMLTextAreaElement> {
    /** The size of the textarea element */
    inputSize?: InputSize;
    value?: string;
    datalist?: any[];
    onListChange: (value: string | undefined) => void;
}
/**解决<input>的局限性；
 * TextArea为基础的附加datalist; 因为input只能单一行的无法适应小屏幕大文本的输入； 由于<input 若用大size参数会有屏幕适应性问题！不建议用size设置尺寸！
 * onChange的差别！ props透传赋值的 前面的{...other} 被后面的同名字onChange所覆盖掉！！
 */
export declare const BlobInputList: React.FunctionComponent<BlobInputListProps>;
