import * as React from "react";
import { PanInfo, MotionValue } from "framer-motion";
export type CarouselProps = {
    children: React.ReactNode;
    renderArrowLeft?: (args: {
        handlePrev: () => void;
        activeIndex: number;
    }) => React.ReactNode;
    renderArrowRight?: (args: {
        handleNext: () => void;
        activeIndex: number;
    }) => React.ReactNode;
    renderDots?: (args: Omit<DotProps, 'length'>) => React.ReactNode;
    autoPlay?: boolean;
    interval?: number;
    loop?: boolean;
};
export type ArrowProps = {
    onClick: () => void;
    left?: boolean;
    children: React.ReactNode;
};
export type SliderProps = {
    x: MotionValue<number>;
    i: number;
    children: React.ReactNode;
    onDragEnd: (e: Event, dragProps: PanInfo) => void;
};
export type DotProps = {
    length: number;
    activeIndex: number;
    setActiveIndex: (index: number) => void;
};
/** @Depracated
 * 等待删除； 请使用<Tabs> <Pager> <ListItem> loadmore Filter...其它思路来替代。
 * "framer-motion"的拉拽事件处理方式无法和"@use-gesture/react"配合。
 * 图片的轮播；
* */
export declare const Carousel: ({ children, renderArrowLeft, renderArrowRight, renderDots, autoPlay, interval, loop, }: CarouselProps) => JSX.Element;
