/** @jsxImportSource @emotion/react */
import { SerializedStyles } from "@emotion/react";
import * as React from "react";
export declare function useCollapse(defaultShow?: boolean, press?: boolean): {
    show: boolean;
    setShow: React.Dispatch<React.SetStateAction<boolean>>;
    id: string;
    buttonProps: {
        onClick: () => void;
        onPress: () => void;
        "aria-controls": string;
        "aria-expanded": boolean;
    };
    collapseProps: {
        id: string;
        show: boolean;
    };
};
interface AnimateCollapseProps extends React.HTMLAttributes<HTMLDivElement> {
    /** A unique id required for accessibility purposes. */
    id: string;
    /** Controls whether the children should be visible */
    show: boolean;
    /** Any element that you want to reveal */
    children: React.ReactNode;
    divStyle?: SerializedStyles;
}
/**
 * Hide and reveal content with an animation. Supports dynamic
 * heights.
 */
export declare const AnimateCollapse: React.FunctionComponent<AnimateCollapseProps>;
interface CollapseProps extends React.HTMLAttributes<HTMLDivElement> {
    /** A unique id required for accessibility purposes. */
    id: string;
    /** Controls whether the children should be visible */
    show: boolean;
    /** Any element that you want to reveal */
    children: React.ReactNode;
    divStyle?: SerializedStyles;
    noAnimated?: boolean;
}
/**
 * Hide and reveal content with an animation. Supports dynamic heights.
 * 针对两种方式取舍display:'none', 和 show&& (<div>{children}</div>)比较，还是逻辑隐藏更好，若遇到耗时子组件时表现更好。
 */
export declare const Collapse: React.FunctionComponent<CollapseProps>;
export declare function usePrevious<T>(value: T): T;
interface LazyToggleViewerProps {
    show: boolean;
    children?: React.ReactNode;
}
export declare const LazyToggleViewer: React.FunctionComponent<LazyToggleViewerProps>;
interface TestRenderLoadProps {
    loop?: number;
    num?: number;
    txt?: string;
}
export declare const TestRenderLoad: React.FunctionComponent<TestRenderLoadProps>;
export {};
