import { jsx as _jsx } from "@emotion/react/jsx-runtime";
import * as React from "react";
import { InputGroupContext } from "./Form";
/**针对没有 <InputLine 来包裹配合的输入组件， 该情形下的InputDatalist <datalist id={`list${uid}`}>出现问题：
 为了避免InputDatalist 因uid缺失导致 多个datalist出现混淆情况
 */
export const InputIdProvider = ({ id, children, ...other }) => {
    const uid = React.useId();
    return (_jsx(InputGroupContext.Provider, { value: {
            uid,
        }, children: children }));
};
//# sourceMappingURL=FormX.js.map